DevExtreme v24.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Scheduler - Work Shifts

This demo uses the JavaScript Scheduler component’s offset property to indicate the starting point of a day. The JavaScript Scheduler’s offset can be set in multiples of 5 and can range from -1440 minutes (-24 hours) to 1440 minutes (24 hours).

For instance, if you set the offset to -120, like the First shift in this demo, the day begins at 10:00 PM on the previous day instead of 00:00. If you set the offset to 360, like the Second shift, the day begins at 6:00 AM.

You can also combine this property with startDayHour, endDayHour, and cellDuration to obtain desired display results.

Backend API
$(() => { const scheduler = $('#scheduler').dxScheduler({ timeZone: 'America/Los_Angeles', dataSource: data, views: ['day', 'workWeek'], currentView: 'workWeek', currentDate: new Date(2021, 2, 30), startDayHour: 0, endDayHour: 8, offset: shifts[0].offset, cellDuration: 60, showAllDayPanel: false, }).dxScheduler('instance'); $('#shifts').dxRadioGroup({ items: shifts, value: shifts[0], layout: 'horizontal', onValueChanged: (e) => { scheduler.option('offset', e.value.offset); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div class="options"> <div class="option"> <div class="label">Work Hours:</div> <div class="value"> <div id="shifts"></div> </div> </div> </div> <br /> <div id="scheduler"></div> </div> </body> </html>
.options { background-color: rgba(191, 191, 191, 0.15); margin-top: 20px; display: flex; align-items: flex-start; height: 100%; } .option { padding: 16px; display: flex; align-items: center; } .label, .value { display: inline-block; vertical-align: middle; } .label { width: 100px; }
const shifts = [{ text: 'First shift', offset: -120, }, { text: 'Second shift', offset: 360, }, { text: 'Third shift', offset: 840, }]; const data = [{ text: 'Website Re-Design Plan', startDate: '2021-03-29T16:00:00.000Z', endDate: '2021-03-29T18:00:00.000Z', }, { text: 'Approve Personal Computer Upgrade Plan', startDate: '2021-03-31T01:30:00.000Z', endDate: '2021-03-31T03:00:00.000Z', }, { text: 'Final Budget Review', startDate: '2021-03-30T16:30:00.000Z', endDate: '2021-03-30T18:05:00.000Z', }, { text: 'New Brochures', startDate: '2021-04-01T23:30:00.000Z', endDate: '2021-04-02T02:30:00.000Z', }, { text: 'Approve New Online Marketing Strategy', startDate: '2021-03-31T16:30:00.000Z', endDate: '2021-03-31T18:30:00.000Z', }, { text: 'Prepare 2021 Marketing Plan', startDate: '2021-04-01T16:30:00.000Z', endDate: '2021-04-01T18:00:00.000Z', }, { text: 'Brochure Design Review', startDate: '2021-04-02T17:30:00.000Z', endDate: '2021-04-02T19:00:00.000Z', }, { text: 'Create Icons for Website', startDate: '2021-04-01T18:00:00.000Z', endDate: '2021-04-01T19:30:00.000Z', }, { text: 'Submit New Website Design', startDate: '2021-04-02T09:30:00.000Z', endDate: '2021-04-02T11:00:00.000Z', }, { text: 'Launch New Website', startDate: '2021-04-01T01:30:00.000Z', endDate: '2021-04-01T03:00:00.000Z', recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2', }, { text: 'Install New Router in Dev Room', startDate: '2021-03-29T08:00:00.000Z', endDate: '2021-03-29T09:00:00.000Z', }, { text: 'Upgrade Personal Computers', startDate: '2021-03-30T01:00:00.000Z', endDate: '2021-03-30T03:00:00.000Z', }, { text: 'Install New Database', startDate: '2021-03-31T08:30:00.000Z', endDate: '2021-03-31T10:00:00.000Z', }, { text: 'Update Customer Shipping Profiles', startDate: '2021-04-01T09:30:00.000Z', endDate: '2021-04-01T11:00:00.000Z', recurrenceRule: 'FREQ=WEEKLY;BYDAY=TH', }, { text: 'Upgrade Server Hardware', startDate: '2021-03-30T08:30:00.000Z', endDate: '2021-03-30T11:00:00.000Z', recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=30', }];

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Scheduler - Work Shifts
This demo uses the Scheduler component’s offset property to indicate the starting point of a day. The Scheduler’s offset can be set in multiples of 5 and can range from -1440 minutes (-24 hours) to 1440 minutes (24 hours).
For instance, if you set the offset to -120, like the First shift in this demo, the day begins at 10:00 PM on the previous day instead of 00:00. If you set the offset to 360, like the Second shift, the day begins at 6:00 AM.
You can also combine this property with startDayHour, endDayHour, and cellDuration to obtain desired display results.
Backend API
<template>
<div class="options">
<div class="option">
<div class="label">Work Hours:</div>
<div class="value">
<DxRadioGroup
:items="shifts"
:value="shifts[0]"
layout="horizontal"
:on-value-changed="onShiftChanged"
/>
</div>
</div>
</div>
<br>
<DxScheduler
time-zone="America/Los_Angeles"
:data-source="appointments"
:current-date="currentDate"
:views="views"
current-view="workWeek"
:start-day-hour="0"
:end-day-hour="8"
:offset="currentOffset"
:cell-duration="60"
:show-all-day-panel="false"
/>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxScheduler from 'devextreme-vue/scheduler';
import DxRadioGroup, { type DxRadioGroupTypes } from 'devextreme-vue/radio-group';
import { appointments, shifts } from './data.ts';
const views = ['day', 'workWeek'];
const currentDate = new Date(2021, 2, 30);
const currentOffset = ref(shifts[0].offset);
function onShiftChanged(e: DxRadioGroupTypes.ValueChangedEvent) {
currentOffset.value = e.value.offset as number;
}
</script>
<style scoped>
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
height: 100%;
}
.option {
padding: 16px;
display: flex;
align-items: center;
}
.label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 100px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
type Shift = {
text: string;
offset: number;
};
type Appointment = {
text: string,
startDate: string,
endDate: string,
recurrenceRule?: string,
};
export const shifts: Shift[] = [{
text: 'First shift',
offset: -120,
}, {
text: 'Second shift',
offset: 360,
}, {
text: 'Third shift',
offset: 840,
}];
export const appointments: Appointment[] = [{
text: 'Website Re-Design Plan',
startDate: '2021-03-29T16:00:00.000Z',
endDate: '2021-03-29T18:00:00.000Z',
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: '2021-03-31T01:30:00.000Z',
endDate: '2021-03-31T03:00:00.000Z',
}, {
text: 'Final Budget Review',
startDate: '2021-03-30T16:30:00.000Z',
endDate: '2021-03-30T18:05:00.000Z',
}, {
text: 'New Brochures',
startDate: '2021-04-01T23:30:00.000Z',
endDate: '2021-04-02T02:30:00.000Z',
}, {
text: 'Approve New Online Marketing Strategy',
startDate: '2021-03-31T16:30:00.000Z',
endDate: '2021-03-31T18:30:00.000Z',
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-01T16:30:00.000Z',
endDate: '2021-04-01T18:00:00.000Z',
}, {
text: 'Brochure Design Review',
startDate: '2021-04-02T17:30:00.000Z',
endDate: '2021-04-02T19:00:00.000Z',
}, {
text: 'Create Icons for Website',
startDate: '2021-04-01T18:00:00.000Z',
endDate: '2021-04-01T19:30:00.000Z',
}, {
text: 'Submit New Website Design',
startDate: '2021-04-02T09:30:00.000Z',
endDate: '2021-04-02T11:00:00.000Z',
}, {
text: 'Launch New Website',
startDate: '2021-04-01T01:30:00.000Z',
endDate: '2021-04-01T03:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2',
}, {
text: 'Install New Router in Dev Room',
startDate: '2021-03-29T08:00:00.000Z',
endDate: '2021-03-29T09:00:00.000Z',
}, {
text: 'Upgrade Personal Computers',
startDate: '2021-03-30T01:00:00.000Z',
endDate: '2021-03-30T03:00:00.000Z',
}, {
text: 'Install New Database',
startDate: '2021-03-31T08:30:00.000Z',
endDate: '2021-03-31T10:00:00.000Z',
}, {
text: 'Update Customer Shipping Profiles',
startDate: '2021-04-01T09:30:00.000Z',
endDate: '2021-04-01T11:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=TH',
}, {
text: 'Upgrade Server Hardware',
startDate: '2021-03-30T08:30:00.000Z',
endDate: '2021-03-30T11:00:00.000Z',
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=30',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>

Backend API
import React, { useState } from 'react';
import Scheduler from 'devextreme-react/scheduler';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import RadioGroup from 'devextreme-react/radio-group';
import { data, shifts } from './data.ts';
const currentDate = new Date(2021, 2, 30);
const views: SchedulerTypes.ViewType[] = ['day', 'workWeek'];
const App = () => {
const [currentShift, setCurrentShift] = useState(shifts[0]);
return <>
<div className="options">
<div className="option">
<div className="label">Work Hours:</div>
<div className="value">
<RadioGroup
defaultValue={shifts[0]}
items={shifts}
layout= 'horizontal'
onValueChange={setCurrentShift}
/>
</div>
</div>
</div>
<br />
<Scheduler
timeZone= 'America/Los_Angeles'
dataSource={data}
views={views}
defaultCurrentView='workWeek'
currentDate={currentDate}
startDayHour= {0}
endDayHour= {8}
offset={currentShift.offset}
cellDuration={60}
showAllDayPanel={false}
/>
</>;
};
export default App;
import React, { useState } from 'react';
import Scheduler from 'devextreme-react/scheduler';
import RadioGroup from 'devextreme-react/radio-group';
import { data, shifts } from './data.js';
const currentDate = new Date(2021, 2, 30);
const views = ['day', 'workWeek'];
const App = () => {
const [currentShift, setCurrentShift] = useState(shifts[0]);
return (
<>
<div className="options">
<div className="option">
<div className="label">Work Hours:</div>
<div className="value">
<RadioGroup
defaultValue={shifts[0]}
items={shifts}
layout="horizontal"
onValueChange={setCurrentShift}
/>
</div>
</div>
</div>
<br />
<Scheduler
timeZone="America/Los_Angeles"
dataSource={data}
views={views}
defaultCurrentView="workWeek"
currentDate={currentDate}
startDayHour={0}
endDayHour={8}
offset={currentShift.offset}
cellDuration={60}
showAllDayPanel={false}
/>
</>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
type Shift = {
text: string;
offset: number;
};
export const shifts: Shift[] = [{
text: 'First shift',
offset: -120,
}, {
text: 'Second shift',
offset: 360,
}, {
text: 'Third shift',
offset: 840,
}];
export const data: SchedulerTypes.Appointment[] = [{
text: 'Website Re-Design Plan',
startDate: '2021-03-29T16:00:00.000Z',
endDate: '2021-03-29T18:00:00.000Z',
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: '2021-03-31T01:30:00.000Z',
endDate: '2021-03-31T03:00:00.000Z',
}, {
text: 'Final Budget Review',
startDate: '2021-03-30T16:30:00.000Z',
endDate: '2021-03-30T18:05:00.000Z',
}, {
text: 'New Brochures',
startDate: '2021-04-01T23:30:00.000Z',
endDate: '2021-04-02T02:30:00.000Z',
}, {
text: 'Approve New Online Marketing Strategy',
startDate: '2021-03-31T16:30:00.000Z',
endDate: '2021-03-31T18:30:00.000Z',
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-01T16:30:00.000Z',
endDate: '2021-04-01T18:00:00.000Z',
}, {
text: 'Brochure Design Review',
startDate: '2021-04-02T17:30:00.000Z',
endDate: '2021-04-02T19:00:00.000Z',
}, {
text: 'Create Icons for Website',
startDate: '2021-04-01T18:00:00.000Z',
endDate: '2021-04-01T19:30:00.000Z',
}, {
text: 'Submit New Website Design',
startDate: '2021-04-02T09:30:00.000Z',
endDate: '2021-04-02T11:00:00.000Z',
}, {
text: 'Launch New Website',
startDate: '2021-04-01T01:30:00.000Z',
endDate: '2021-04-01T03:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2',
}, {
text: 'Install New Router in Dev Room',
startDate: '2021-03-29T08:00:00.000Z',
endDate: '2021-03-29T09:00:00.000Z',
}, {
text: 'Upgrade Personal Computers',
startDate: '2021-03-30T01:00:00.000Z',
endDate: '2021-03-30T03:00:00.000Z',
}, {
text: 'Install New Database',
startDate: '2021-03-31T08:30:00.000Z',
endDate: '2021-03-31T10:00:00.000Z',
}, {
text: 'Update Customer Shipping Profiles',
startDate: '2021-04-01T09:30:00.000Z',
endDate: '2021-04-01T11:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=TH',
}, {
text: 'Upgrade Server Hardware',
startDate: '2021-03-30T08:30:00.000Z',
endDate: '2021-03-30T11:00:00.000Z',
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=30',
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const shifts = [
{
text: 'First shift',
offset: -120,
},
{
text: 'Second shift',
offset: 360,
},
{
text: 'Third shift',
offset: 840,
},
];
export const data = [
{
text: 'Website Re-Design Plan',
startDate: '2021-03-29T16:00:00.000Z',
endDate: '2021-03-29T18:00:00.000Z',
},
{
text: 'Approve Personal Computer Upgrade Plan',
startDate: '2021-03-31T01:30:00.000Z',
endDate: '2021-03-31T03:00:00.000Z',
},
{
text: 'Final Budget Review',
startDate: '2021-03-30T16:30:00.000Z',
endDate: '2021-03-30T18:05:00.000Z',
},
{
text: 'New Brochures',
startDate: '2021-04-01T23:30:00.000Z',
endDate: '2021-04-02T02:30:00.000Z',
},
{
text: 'Approve New Online Marketing Strategy',
startDate: '2021-03-31T16:30:00.000Z',
endDate: '2021-03-31T18:30:00.000Z',
},
{
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-01T16:30:00.000Z',
endDate: '2021-04-01T18:00:00.000Z',
},
{
text: 'Brochure Design Review',
startDate: '2021-04-02T17:30:00.000Z',
endDate: '2021-04-02T19:00:00.000Z',
},
{
text: 'Create Icons for Website',
startDate: '2021-04-01T18:00:00.000Z',
endDate: '2021-04-01T19:30:00.000Z',
},
{
text: 'Submit New Website Design',
startDate: '2021-04-02T09:30:00.000Z',
endDate: '2021-04-02T11:00:00.000Z',
},
{
text: 'Launch New Website',
startDate: '2021-04-01T01:30:00.000Z',
endDate: '2021-04-01T03:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2',
},
{
text: 'Install New Router in Dev Room',
startDate: '2021-03-29T08:00:00.000Z',
endDate: '2021-03-29T09:00:00.000Z',
},
{
text: 'Upgrade Personal Computers',
startDate: '2021-03-30T01:00:00.000Z',
endDate: '2021-03-30T03:00:00.000Z',
},
{
text: 'Install New Database',
startDate: '2021-03-31T08:30:00.000Z',
endDate: '2021-03-31T10:00:00.000Z',
},
{
text: 'Update Customer Shipping Profiles',
startDate: '2021-04-01T09:30:00.000Z',
endDate: '2021-04-01T11:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=TH',
},
{
text: 'Upgrade Server Hardware',
startDate: '2021-03-30T08:30:00.000Z',
endDate: '2021-03-30T11:00:00.000Z',
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=30',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
height: 100%;
}
.option {
padding: 16px;
display: flex;
align-items: center;
}
.label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 100px;
}

Backend API
<div class="options">
<div class="option">
<div class="label">Work Hours:</div>
<div class="value">
<dx-radio-group
[items]="shifts"
[(value)]="currentShift"
layout="horizontal"
>
</dx-radio-group>
</div>
</div>
</div>
<br />
<dx-scheduler
timeZone="America/Los_Angeles"
[dataSource]="appointments"
[views]="['day', 'workWeek']"
currentView="workWeek"
[currentDate]="currentDate"
[startDayHour]="0"
[endDayHour]="8"
[cellDuration]="60"
[offset]="currentShift.offset"
[showAllDayPanel]="false"
>
</dx-scheduler>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxSchedulerModule, DxRadioGroupModule } from 'devextreme-angular';
import { Service, Appointment, Shift } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxSchedulerModule,
DxRadioGroupModule,
],
})
export class AppComponent {
appointments: Appointment[];
shifts: Shift[];
currentShift: Shift;
currentDate: Date = new Date(2021, 2, 30);
constructor(service: Service) {
this.appointments = service.getAppointments();
this.shifts = service.getShifts();
this.currentShift = this.shifts[0];
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
height: 100%;
}
.option {
padding: 16px;
display: flex;
align-items: center;
}
.label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 100px;
}
import { Injectable } from '@angular/core';
export type Shift = {
text: string;
offset: number;
};
export type Appointment = {
text: string,
startDate: string,
endDate: string,
recurrenceRule?: string,
};
export const shifts: Shift[] = [{
text: 'First shift',
offset: -120,
}, {
text: 'Second shift',
offset: 360,
}, {
text: 'Third shift',
offset: 840,
}];
export const appointments: Appointment[] = [{
text: 'Website Re-Design Plan',
startDate: '2021-03-29T16:00:00.000Z',
endDate: '2021-03-29T18:00:00.000Z',
}, {
text: 'Approve Personal Computer Upgrade Plan',
startDate: '2021-03-31T01:30:00.000Z',
endDate: '2021-03-31T03:00:00.000Z',
}, {
text: 'Final Budget Review',
startDate: '2021-03-30T16:30:00.000Z',
endDate: '2021-03-30T18:05:00.000Z',
}, {
text: 'New Brochures',
startDate: '2021-04-01T23:30:00.000Z',
endDate: '2021-04-02T02:30:00.000Z',
}, {
text: 'Approve New Online Marketing Strategy',
startDate: '2021-03-31T16:30:00.000Z',
endDate: '2021-03-31T18:30:00.000Z',
}, {
text: 'Prepare 2021 Marketing Plan',
startDate: '2021-04-01T16:30:00.000Z',
endDate: '2021-04-01T18:00:00.000Z',
}, {
text: 'Brochure Design Review',
startDate: '2021-04-02T17:30:00.000Z',
endDate: '2021-04-02T19:00:00.000Z',
}, {
text: 'Create Icons for Website',
startDate: '2021-04-01T18:00:00.000Z',
endDate: '2021-04-01T19:30:00.000Z',
}, {
text: 'Submit New Website Design',
startDate: '2021-04-02T09:30:00.000Z',
endDate: '2021-04-02T11:00:00.000Z',
}, {
text: 'Launch New Website',
startDate: '2021-04-01T01:30:00.000Z',
endDate: '2021-04-01T03:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=WE;INTERVAL=2',
}, {
text: 'Install New Router in Dev Room',
startDate: '2021-03-29T08:00:00.000Z',
endDate: '2021-03-29T09:00:00.000Z',
}, {
text: 'Upgrade Personal Computers',
startDate: '2021-03-30T01:00:00.000Z',
endDate: '2021-03-30T03:00:00.000Z',
}, {
text: 'Install New Database',
startDate: '2021-03-31T08:30:00.000Z',
endDate: '2021-03-31T10:00:00.000Z',
}, {
text: 'Update Customer Shipping Profiles',
startDate: '2021-04-01T09:30:00.000Z',
endDate: '2021-04-01T11:00:00.000Z',
recurrenceRule: 'FREQ=WEEKLY;BYDAY=TH',
}, {
text: 'Upgrade Server Hardware',
startDate: '2021-03-30T08:30:00.000Z',
endDate: '2021-03-30T11:00:00.000Z',
recurrenceRule: 'FREQ=MONTHLY;BYMONTHDAY=30',
}];
@Injectable()
export class Service {
getShifts() {
return shifts;
}
getAppointments() {
return appointments;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>